Unit FTA2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTA1Z_p;

procedure FTA2e(var ARRAY1 :Array of Extended;
                var ARRAY2 :Array of Extended;
                var FFTA1 :Array of Complex;
                var FFTA2 :Array of Complex; N :Integer);

implementation

procedure FTA2e(var ARRAY1 :Array of Extended;
                var ARRAY2 :Array of Extended;
                var FFTA1 :Array of Complex;
                var FFTA2 :Array of Complex; N :Integer);
var
J,N21,N2,N2J :Integer;
H1,H2,C1,C2 :Complex;
_i : Integer;
_ear :Array of Extended;   //  
label
_10,_20;
begin
SetLength(_ear,2*(High(FFTA1)+1));  //   

C1 := Cmplx(0.5e0,0.0e0);
C2 := Cmplx(0.0e0,-0.5e0);
for J:=1 to N do
 begin
  FFTA1[J-1] := Cmplx(ARRAY1[J-1],ARRAY2[J-1]);
_10:
 end;
//FTA1Z(FFTA1,N,1);
for _i:=0 to High(FFTA1) do
 begin
 _ear[2*_i] := FFTA1[_i].re; //  
 _ear[2*_i + 1] := FFTA1[_i].im; //  
 end;
FTA1Z(_ear,N,1);
for _i:=0 to High(FFTA1) do
 begin
 FFTA1[_i].re := _ear[2*_i]; //  
 FFTA1[_i].im := _ear[2*_i + 1]; //  
 end;

 FFTA2[0] := Cmplx(Aimag(FFTA1[0]),0.0e0);
FFTA1[0] := Cmplx(Creal(FFTA1[0]),0.0e0);
N2 := N+2;
N21 := Trunc( N/2 )+1;
for J:=2 to N21 do
 begin
  N2J := N2-J;
  H1 := MulC(C1,AddC(FFTA1[J-1],Conjg(FFTA1[N2J-1])));
  H2 := MulC(C2,SubC(FFTA1[J-1],Conjg(FFTA1[N2J-1])));
  FFTA1[J-1] := H1;
  FFTA1[N2J-1] := Conjg(H1);
  FFTA2[J-1] := H2;
  FFTA2[N2J-1] := Conjg(H2);
_20:
 end;
end;

end.
